<?php if (!defined('PmWiki')) exit();
/*
    simple glossary script, version 1.06
    Copyright 2011-2014 John Rankin (john.rankin@affinity.co.nz)
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    
*/

## (:glossary:)
Markup('glossary', 'directives', '/\\(:glossary(end)?:\\)/i', "glossaryHelper");
function glossaryHelper($m) { return PZZ($GLOBALS['Glossary']=($m[1]!='end')); }

SDV($BlockMarkups['gl'], array('<dl class="glossary">','</dd>','</dd></dl>',1));
$HTMLStylesFmt['gls'] = "dl.glossary dt { font-style: italic; }";

## glossary lists
SDV($Glossary, false);
Markup('^G::','<^::','/^(:)(\s*)([^:"\s]+)\s*(?:"(.*?)"(?:(.*?)")?)?:/',
  "gtermHelper");
function gtermHelper($m) {
  return $GLOBALS['Glossary'] ? '<:gl,'.$m[1].','.$m[1].$m[2].'><dt id="'.$m[3].'">'.
      $m[2].($m[4] ? $m[4] : GlossSpaced($m[3])).'</dt><dd>' : $m[0];
}
function GlossSpaced($term) { return str_replace('_',' ',$term); }

SDV($GlossaryPage, 'Glossary');
Markup_e('gls_', '<inline', "/gls\(_?\)/","'gls('.RandGlossKey(\$pagename).')'");
Markup_e('gls','inline',"/([Gg])ls(p?)\((?:\"(\\w[-\\w]*)\")?\\s*(\\w[-\\w]*)\\s*\)(['\\w]*)/",
  "'<a href=\"#'.\$m[4].'\">'.GlossaryLinkText(\$pagename, \$m[1], \$m[2], \$m[3], \$m[4], \$m[5]).'</a>'");
Markup_e('gabbr1','<inline',"/`([[:lower:]][-[:lower:]0-9]*)\\b/",
  "AbbreviationLinkText(\$pagename, \$m[1])");
Markup_e('gabbr2','<inline',"/`([[:upper:]][-[:upper:]0-9]*)(['\\w]*)\\b(\s*\|)?/",
  "AbbreviationLinkText(\$pagename, \$m[1], \$m[2], \$m[3])");
Markup_e('glsa','directives',"/gls\(\\s*`(\\w[-\\w]*)\\s*\)(['\\w]*)/",
  "'<a href=\"#'.\$m[1].'\">'.AbbreviationGlossaryText(\$pagename, \$m[1], \$m[2]).'</a>'");
Markup_e('glss','directives',"/([Gg])lss(p?)\((?:\"(\\w[-\\w]*)\")?\\s*(\\w[-\\w]*)\\s*\)(['\\w]*)/",
  "GlossaryXrefText(\$pagename, \$m[1], \$m[2], \$m[3], \$m[4], \$m[5])");
Markup('glss1','<glss','/([Gg]ls)(p?\((?:\"(\\w[-\\w]*)\")?\\s*\\w[-\\w]*\\s*\))/',
  "glss1Helper");
Markup('^glss','<glss','/^:\s*([^:"\s]+)\s*(?:"(.*?)"(?:(.*?)")?)?:/',
  "glssHelper");
function glss1Helper($m) { return $GLOBALS['Glossary'] ? $m[1].'s'.$m[2] : $m[0]; }
function glssHelper($m) {
  return $m[0].($GLOBALS['Glossary'] ? PZZ($GLOBALS['SavedGlossKey']=$m[1]) : '');
}
function PageGlossaryKey($pagename, $var) {
  global $PCache, $GlossaryPattern, $MaxPageTextVars;
  SDV($GlossaryPattern, 
      array('key' => '/^(:)(\s*)([^:"\s]+)\s*(?:"(.*?)"(?:(.*?)")?)?:(.*?)$/m'));
  SDV($MaxPageTextVars, 500);
  static $status;
  if(@$status["$pagename:$var"]++ > $MaxPageTextVars) return '';
  if (!@$PCache[$pagename]['=pagetextvars']) {
    $pc = &$PCache[$pagename];
    $pc['=pagetextvars'] = 1;
    $page = RetrieveAuthPage($pagename, 'read', false, READPAGE_CURRENT);
    if ($page) {
      foreach((array)$GlossaryPattern as $pat) 
        if (preg_match_all($pat, IsEnabled($PCache[$pagename]['=preview'],
                                           preg_replace("/\n([-\s*#]+|::+)/",'<n:>$1',@$page['text'])), 
                           $match, PREG_SET_ORDER))
          foreach($match as $m)
            $pc["=p_{$m[3]}"] = array('term' => $m[4] ? trim($m[4]) : GlossSpaced($m[3]),
                                      'plur' => trim($m[5]),
                                      'desc' => str_replace('<n:>',"\n",trim($m[6])));
    }
  }
  if ($var=='_') {
      $keys = array_keys($PCache[$pagename]);
      return str_replace('=p_','',$keys[rand(2, count($keys)-1)]);
  }
  return @$PCache[$pagename]["=p_$var"];
}

function RandGlossKey($page) {
  global $GlossaryPage;
  return PageGlossaryKey(MakePageName($page, $GlossaryPage), '_');
}

function GlossaryChildren($page, $key, $desc) {
  global $SeenGloss;
  @$SeenGloss[$key]++;
  if ($SeenGloss[$key]==1) {
      preg_match_all('/[Gg]lss?p?\((?:\"\\w[-\\w]*\")?\\s*(\\w[-\\w]*)\\s*\)/', $desc, $match, PREG_SET_ORDER);
      foreach($match as $m) {
        $g = PageGlossaryKey($page, $m[1]);
        GlossaryChildren($page, $m[1], $g['desc']);
      }
  }
}

function GlossaryLinkTextString($g, $upper, $plural, $prefix, $key, $suffix) {
  global $Charset;
  $g['plur'] = $suffix ? preg_replace('/\|.*$/','',$g['plur']) 
                       : str_replace('|','',$g['plur']);
  $text = $g['term'] ? GlossSpaced($prefix).($plural ? ($g['plur'] ? $g['plur'] 
                                              : $g['term'].'s') 
                                : $g['term']) 
                     : '*'.GlossSpaced($prefix.$key);
  if ($upper=='G') $text[0] = strtoupper($text[0]);
  $suffix = GlossSpaced($suffix);
  return htmlspecialchars("$text$suffix", ENT_NOQUOTES, $Charset);
}

function GlossaryLinkText($page, $upper, $plural, $prefix, $key, $suffix) {
  global $GlossaryPage, $SeenGlossLink, $SeenGlossSilent;
  $gpage = MakePageName($page, $GlossaryPage);
  $g = PageGlossaryKey($gpage, $key);
  if (!@$SeenGlossSilent[$key]) {
      @$SeenGlossLink[$key]++;
      GlossaryChildren($gpage, $key, $g['desc']);
  }
  return GlossaryLinkTextString($g, $upper, $plural, $prefix, $key, $suffix);
}

function AbbreviationLinkText($page, $key, $suffix=NULL, $abb=NULL) {
  global $GlossaryPage, $SeenAbbr;
  @$SeenAbbr[$key]++;
  if ($abb) return "`$key$suffix|";
  $g = PageGlossaryKey(MakePageName($page, $GlossaryPage), $key);
  $term = strtoupper($g['term'] ? $g['term'] : $key).$suffix;
  $desc = trim(preg_replace_callback(
                   "/[Gg]lss?p?\(\\s*(\\w[-\\w]*)\\s*\)(['\\w]*)/",
                   function ($m) { return GlossSpaced($m[1].$m[2]); },
                   $g['desc']));
  return $g['term'] ? (($SeenAbbr[$key]>1) ? '`'.$term 
                                           : '{`'.$term.'|'.$desc.'}') 
                    : '`'.$term;
}

function AbbreviationGlossaryText($page, $key, $suffix) {
  global $GlossaryPage, $SeenGlossLink, $SeenGlossSilent;
  if (!@$SeenGlossSilent[$key]) {
      @$SeenGlossLink[$key]++;
      $gpage = MakePageName($page, $GlossaryPage);
      $g = PageGlossaryKey($gpage, $key);
      GlossaryChildren($gpage, $key, $g['desc']);
  }
  return AbbreviationLinkText($page, $key, $suffix);
}

function GlossaryXrefText($page, $upper, $plural, $prefix, $key, $suffix) {
  global $GlossaryPage, $SeenGlossSilent, $SavedGlossKey;
  if ($key!=$SavedGlossKey) $SeenGlossSilent[$key]++;
  $g = PageGlossaryKey(MakePageName($page, $GlossaryPage), $key);
  return ($SeenGlossSilent[$key]>1 || $g['term']=='' || $key==$SavedGlossKey)
      ? "'''".GlossaryLinkTextString($g, $upper, $plural, $prefix, $key, $suffix)."'''"
      : $upper."ls$plural(".($prefix ? '"'.$prefix.'"' : '')."$key)$suffix";
}

$HTMLFooterFmt['gls'] = 'function:GlossaryList';
function GlossaryList($pagename) {
  global $GlossaryPage, $SeenGloss, $SeenAbbr, $GlossaryTag, $MinGlossCount;
  SDV($GlossaryTag, array('open'  => '<div id="glossary">',
                          'head'  => '<h2 class="glossary">$Page</h2>'."\n",
                          'break' => '!!! $Letter'."\n\n",
                          'close' => '</div>'));
  SDV($MinGlossCount,10);
  $gpage = MakePageName($pagename, $GlossaryPage);
  $aKeys = array_keys((array)$SeenGloss);
  natcasesort($aKeys);
  $gSorted = array();
  $gBreak  = (count($aKeys)>$MinGlossCount) ? '' : 'Z';
  foreach ($aKeys as $k) {
    $g = PageGlossaryKey($gpage, $k);
    if (@$SeenAbbr[$k]) $g['term'] = strtoupper($g['term']);
    $gLetter = strtoupper($k[0]);
    if ($gLetter>$gBreak) {
        $l = str_replace('$Letter', $gLetter, $GlossaryTag['break']);
        $gBreak = $gLetter;
    } else
        $l = '';
    $gSorted[] = $l.":$k".'"'.$g['term'].'":'.($g['desc'] ? $g['desc'] : '?');
  }
  echo count($gSorted) ? $GlossaryTag['open'].
                         str_replace('$Page', $GlossaryPage, $GlossaryTag['head']).
                         MarkupToHTML($pagename, "(:glossary:)\n".
                                                 implode("\n\n", $gSorted).
                                                 "\n(:glossaryend:)").
                         $GlossaryTag['close'] : '';
}

?>
